Index: cprs/trunk/CPRS-Chart/fGraphs.pas
===================================================================
--- cprs/trunk/CPRS-Chart/fGraphs.pas	(revision 456)
+++ cprs/trunk/CPRS-Chart/fGraphs.pas	(revision 830)
@@ -3149,96 +4194,28 @@
   titleitem := ItemName(Piece(aTypeItem, '^', 1), Piece(aTypeItem, '^', 2));
   rpcDetailDay(tmpList, Patient.DFN, date1, date2, aTypeItem, true);
+  NotifyApps(tmpList);
   ReportBox(tmpList, titletype + ': ' + titleitem + ' on ' + Patient.Name + ' for ' + FormatFMDateTime('mmm d, yyyy', date1), True);
   tmpList.Free;
 end;
 
-procedure TfrmGraphs.mnuPopGraphCopyClick(Sender: TObject);
+procedure TfrmGraphs.NotifyApps(aList: TStrings);
 var
   i: integer;
-  StrForFooter, StrForHeader, aTitle, aWarning, aDateRange: String;
-  aHeader: TStringList;
-  wrdApp, wrdDoc: Variant;
-  ChildControl: TControl;
-begin
-  try
-    wrdApp := CreateOleObject('Word.Application');
-  except
-    raise Exception.Create('Cannot start MS Word!');
-  end;
-  Screen.Cursor := crHourGlass;
-  aTitle := 'CPRS Graphing';
-  aWarning := pnlInfo.Caption;
-  aDateRange :=  'Date Range: ' + cboDateRange.Text + '  Selected Items from ' +
-      FormatDateTime('mm/dd/yy', FGraphSetting.LowTime) + ' to ' +
-      FormatDateTime('mm/dd/yy', FGraphSetting.HighTime);
-  aHeader := TStringList.Create;
-  CreatePatientHeader(aHeader, aTitle, aWarning, aDateRange);
-  StrForHeader := '';
-  for i := 0 to aHeader.Count -1 do
-    StrForHeader := StrForHeader + aHeader[i] + Chr(13);
-  StrForFooter := aTitle + ' - *** WORK COPY ONLY ***' + Chr(13);
-  wrdApp.Visible := False;
-  wrdApp.Documents.Add;
-  wrdDoc := wrdApp.Documents.Item(1);
-  wrdDoc := wrdDoc.Sections.Item(1);
-  wrdDoc := wrdDoc.Headers.Item(1).Range;
-  wrdDoc.Font.Name := 'Courier New';
-  wrdDoc.Font.Size := 9;
-  wrdDoc.Text := StrForHeader;
-  wrdDoc := wrdApp.Documents.Item(1);
-  wrdDoc := wrdDoc.Sections.Item(1);
-  wrdDoc := wrdDoc.Footers.Item(1);
-  wrdDoc.Range.Font.Name := 'Courier New';
-  wrdDoc.Range.Font.Size := 9;
-  wrdDoc.Range.Text := StrForFooter;
-  wrdDoc.PageNumbers.Add;
-  wrdDoc := wrdApp.Documents.Item(1);
-  wrdDoc.Range.Font.Name := 'Courier New';
-  wrdDoc.Range.Font.Size := 9;
-  wrdDoc.Range.Text := StrForHeader;
-  wrdDoc.Range.InsertParagraphAfter;
-  for i := 0 to scrlTop.ControlCount - 1 do           // goes from top to bottom
-  begin
-    ChildControl := scrlTop.Controls[i];
-    if (ChildControl as TChart).Visible then
-    begin
-      (ChildControl as TChart).CopyToClipboardBitmap;
-      wrdDoc.Range.InsertParagraphAfter;
-      wrdDoc.Paragraphs.Last.Range.Paste;
-    end;
-  end;
-  if (chartDatelineTop.SeriesCount > 0) and (not chkItemsTop.Checked) then
-  begin
-    chartDatelineTop.CopyToClipboardBitmap;
-    wrdDoc.Range.InsertParagraphAfter;
-    wrdDoc.Paragraphs.Last.Range.Paste;
-  end;
-  wrdDoc.Range.InsertParagraphAfter;
-  wrdDoc.Paragraphs.Last.Range.Text := '   ';
-  for i := 0 to scrlBottom.ControlCount - 1 do
-  begin
-    ChildControl := scrlBottom.Controls[i];
-    if (ChildControl as TChart).Visible then
-    begin
-      (ChildControl as TChart).CopyToClipboardBitmap;
-      wrdDoc.Range.InsertParagraphAfter;
-      wrdDoc.Paragraphs.Last.Range.Paste;
-    end;
-  end;
-  if (chartDatelineBottom.SeriesCount > 0) and (chkDualViews.Checked)
-    and (not chkItemsBottom.Checked) then
-  begin
-    chartDatelineBottom.CopyToClipboardBitmap;
-    wrdDoc.Range.InsertParagraphAfter;
-    wrdDoc.Paragraphs.Last.Range.Paste;
-  end;
-  wrdDoc.Range.WholeStory;
-  wrdDoc.Range.Copy;
-  wrdDoc.Close(false);
-  wrdApp.DisplayAlerts := false;
-  wrdApp.Quit;
-  wrdApp := Unassigned; // releases variant
-  aHeader.Free;
-  Screen.Cursor := crDefault;
+  info, aID, aTag: string;
+begin
+  for i := aList.Count - 1 downto 0  do
+  begin
+    info := aList[i];
+    if Piece(info, '^', 1 ) = '~~~' then
+    begin
+      aList.Delete(i);
+      if length(Piece(info, '^', 11)) > 0 then
+      begin
+        aID := '';
+        aTag := 'SUR' + '^';
+        //NotifyOtherApps(NAE_REPORT, aTag + aID);
+      end;
+    end;
+  end;
 end;
 
@@ -3250,21 +4227,43 @@
   if Warning = TXT_INFO then Warning := '  ';
   with HeaderList do
-    begin
-      Add(' ');
-      Add(StringOfChar(' ', (74 - Length(PageTitle)) div 2) + PageTitle);
-      Add(' ');
-      tmpStr := Patient.Name + '   ' + Patient.SSN;
-      tmpItem := tmpStr + StringOfChar(' ', 39 - Length(tmpStr)) + Encounter.LocationName;
-      tmpStr := FormatFMDateTime('mmm dd, yyyy', Patient.DOB) + ' (' + IntToStr(Patient.Age) + ')';
-      tmpItem := tmpItem + StringOfChar(' ', 74 - (Length(tmpItem) + Length(tmpStr))) + tmpStr;
-      Add(tmpItem);
-      Add(StringOfChar('=', 74));
-      Add('*** WORK COPY ONLY ***' + StringOfChar(' ', 24) + 'Printed: '
-        + FormatFMDateTime('mmm dd, yyyy  hh:nn', FMNow));
-      Add(TXT_COPY_DISCLAIMER);
-      Add(StringOfChar(' ', (74 - Length(DateRange)) div 2) + DateRange);
-      Add(StringOfChar(' ', (74 - Length(Warning)) div 2) + Warning);
-      Add(' ');
-    end;
+  begin
+    Add(' ');
+    Add(StringOfChar(' ', (74 - Length(PageTitle)) div 2) + PageTitle);
+    Add(' ');
+    tmpStr := Patient.Name + '   ' + Patient.SSN;
+    tmpItem := tmpStr + StringOfChar(' ', 39 - Length(tmpStr)) + Encounter.LocationName;
+{ TODO -oRV -cWVEHR Long Age : Changed to use long age }
+    //tmpStr := FormatFMDateTime('mmm dd, yyyy', Patient.DOB) + ' (' + IntToStr(Patient.Age) + ')';
+    tmpStr := FormatFMDateTime('mmm dd, yyyy', Patient.DOB) + ' (' + GetPatientBriefAge(Patient.DFN) + ')';
+{}
+    tmpItem := tmpItem + StringOfChar(' ', 74 - (Length(tmpItem) + Length(tmpStr))) + tmpStr;
+    Add(tmpItem);
+    Add(StringOfChar('=', 74));
+    Add(' *** WORK COPY ONLY *** ' + StringOfChar(' ', 24) + 'Printed: '
+      + FormatFMDateTime('mmm dd, yyyy  hh:nn', FMNow));
+    Add('  ' + TXT_COPY_DISCLAIMER);
+    Add(StringOfChar(' ', (74 - Length(DateRange)) div 2) + DateRange);
+    Add(StringOfChar(' ', (74 - Length(Warning)) div 2) + Warning);
+    Add(' ');
+  end;
+end;
+
+procedure TfrmGraphs.CreateExcelPatientHeader(var HeaderList: TStringList; PageTitle, DateRange: string);
+// this procedure modified from rReports
+var
+  tmpItem: string;
+begin
+  with HeaderList do
+  begin
+    Add(' ');
+    Add(PageTitle);
+    Add(' ');
+    tmpItem := Patient.Name + '         ' + Patient.SSN + '          '
+             + Encounter.LocationName + '                            '
+             + FormatFMDateTime('mmm dd, yyyy', Patient.DOB) + ' (' + IntToStr(Patient.Age) + ')';
+    Add(tmpItem);
+    //Add(TXT_COPY_DISCLAIMER);  // put on footer to avoid length problems
+    Add(DateRange);
+  end;
 end;
 
@@ -3275,11 +4274,10 @@
   aDate, aDate1: double;
 begin
-  lstTemp.Items.Clear;
+  GtslTemp.Clear;
   itemid := UpperCase(Pieces(aString, '^', 1, 2));
-  with lstData do
-  for i := Items.Count - 1 downto 0 do
-    if itemid = UpperCase(Pieces(Items[i], '^', 1, 2)) then
-    begin
-      itemdata := Items[i];
+  for i := GtslData.Count - 1 downto 0 do
+    if itemid = UpperCase(Pieces(GtslData[i], '^', 1, 2)) then
+    begin
+      itemdata := GtslData[i];
       filenum := Piece(itemdata, '^', 1);
       if (filenum = '52') or (filenum = '55') or (filenum = '55NVA')
@@ -3289,9 +4287,9 @@
         aDate1 := strtofloat(FMCorrectedDate(Piece(itemdata, '^', 4)));
         if (aDate < FGraphSetting.FMStopDate) and (aDate > FGraphSetting.FMStartDate) then
-          lstTemp.Items.Add(Items[i])
+          GtslTemp.Add(GtslData[i])
         else if (aDate < FGraphSetting.FMStopDate) and (aDate1 > FGraphSetting.FMStartDate) then
-          lstTemp.Items.Add(Items[i])
+          GtslTemp.Add(GtslData[i])
         else if (aDate < FGraphSetting.FMStartDate) and (aDate1 > FGraphSetting.FMStopDate) then
-          lstTemp.Items.Add(Items[i]);
+          GtslTemp.Add(GtslData[i]);
       end
       else if Piece(itemdata, '^', 3) <> '' then
@@ -3300,9 +4298,9 @@
         if (aDate < FGraphSetting.FMStopDate) and (aDate > FGraphSetting.FMStartDate) then
           if Copy(itemdata, 1, 4) = '63MI' then
-            lstTemp.Items.Add(Pieces(Items[i], '^', 1, 4))
+            GtslTemp.Add(Pieces(GtslData[i], '^', 1, 4))
           else if Copy(itemdata, 1, 4) = '63AP' then
-            lstTemp.Items.Add(Pieces(Items[i], '^', 1, 4))
-          //else lstTemp.Items.Add(Pieces(Items[i], '^', 1, 5));         // add in non micro, ap
-          else lstTemp.Items.Add(Items[i]);         // add in non micro, ap
+            GtslTemp.Add(Pieces(GtslData[i], '^', 1, 4))
+          //else GtslTemp.Add(Pieces(Items[i], '^', 1, 5));         // add in non micro, ap
+          else GtslTemp.Add(GtslData[i]);         // add in non micro, ap
       end;
     end;
@@ -3328,12 +4326,10 @@
   Result := 4;
   if (aType = '52') or (aType = '55') or (aType = '55NVA') or (aType = '9999911') then
-    if mnuMedsasgantt.Checked then Result := 8
-    else if mnuMedsasganttvertheight.Checked then Result := 3
-    else Result := 8
+    Result := 8
   else
-  for i := 0 to lstAllTypes.Items.Count - 1 do
-    if aType = Piece(lstAllTypes.Items[i], '^', 1) then
-    begin
-      Result := strtointdef(Piece(lstAllTypes.Items[i], '^', 3), 4);
+  for i := 0 to GtslAllTypes.Count - 1 do
+    if aType = Piece(GtslAllTypes[i], '^', 1) then
+    begin
+      Result := strtointdef(Piece(GtslAllTypes[i], '^', 3), 4);
       break;
     end;
@@ -3343,11 +4339,15 @@
 var
   i: integer;
+  astring: string;
 begin
   Result := false;
-  for i := 0 to lstTypes.Items.Count - 1 do
-  if Piece(lstTypes.Items[i], '^', 1) = aType then
-  begin
-    Result := length(Piece(lstTypes.Items[i], '^', 8)) > 0;
-    break;
+  for i := 0 to GtslTypes.Count - 1 do
+  begin
+    astring := GtslTypes[i];
+    if Piece(astring, '^', 1) = aType then
+    begin
+      Result := length(Piece(astring, '^', 8)) > 0;
+      break;
+    end;
   end;
 end;
@@ -3361,9 +4361,8 @@
   done := false;
   j := 0;
-  with lstTempCheck do
   while not done do
   begin
-    if Items.Count = j then done := true
-    else if Items[j] = typeitem then
+    if GtslTempCheck.Count = j then done := true
+    else if GtslTempCheck[j] = typeitem then
     begin
       previous := true;
@@ -3375,6 +4374,6 @@
   if not previous then
   begin
-    lstTempCheck.Items.Add(UpperCase(typeitem));
-    levelseq := lstTempCheck.Items.Count;
+    GtslTempCheck.Add(UpperCase(typeitem));
+    levelseq := GtslTempCheck.Count;
   end;
 end;
@@ -3384,11 +4383,11 @@
   i: integer;
 begin
-  if lstDrugClass.Items.Count < 1 then
-    FastAssign(rpcClass('50.605'), lstDrugClass.Items);
+  if GtslDrugClass.Count < 1 then
+    FastAssign(rpcClass('50.605'), GtslDrugClass);
   Result := '';
-  for i := 0 to lstDrugClass.Items.Count - 1 do
-    if Piece(lstDrugClass.Items[i], '^', 2) = aDCien then
-    begin
-      Result := 'Drug - ' + Piece(lstDrugClass.Items[i], '^', 3);
+  for i := 0 to GtslDrugClass.Count - 1 do
+    if Piece(GtslDrugClass[i], '^', 2) = aDCien then
+    begin
+      Result := 'Drug - ' + Piece(GtslDrugClass[i], '^', 3);
       break;
     end;
@@ -3409,13 +4408,16 @@
 end;
 
+procedure TfrmGraphs.splViewsTopMoved(Sender: TObject);
+begin
+  mnuPopGraphViewDefinition.Checked := (memViewsTop.Height > 5)
+                                    or (memViewsBottom.Height > 5);
+end;
+
 procedure TfrmGraphs.cboDateRangeChange(Sender: TObject);
 var
-  datetag: integer;
-  endofday: double;
-  dateranges, manualstart, manualstop: string;
-begin
-  endofday := FMDateTimeOffsetBy(FMToday, 1);
-  SelCopy(lvwItemsTop, lstSelCopyTop);
-  SelCopy(lvwItemsBottom, lstSelCopyBottom);
+  dateranges: string;
+begin
+  SelCopy(lvwItemsTop, GtslSelCopyTop);
+  SelCopy(lvwItemsBottom, GtslSelCopyBottom);
   dateranges := '';
   if (cboDateRange.ItemID = 'S') then
@@ -3443,5 +4445,24 @@
   end;
   HideGraphs(true);
+  DateSteps(dateranges);
+  FilterListView(FGraphSetting.FMStartDate, FGraphSetting.FMStopDate);
+  SelReset(GtslSelCopyTop, lvwItemsTop);
+  SelReset(GtslSelCopyBottom, lvwItemsBottom);
+  DisplayData('top');
+  DisplayData('bottom');
+  if lstViewsTop.ItemIndex > 1 then lstViewsTopChange(self);
+  if lstViewsBottom.ItemIndex > 1 then lstViewsBottomChange(self);
+  HideGraphs(false);
+end;
+
+procedure TfrmGraphs.DateSteps(dateranges: string);
+var
+  datetag: integer;
+  endofday: double;
+  manualstart, manualstop: string;
+begin
+  endofday := FMDateTimeOffsetBy(FMToday, 1);
   datetag := cboDateRange.ItemIEN;
+  FGraphSetting.FMStopDate := endofday;
   with FGraphSetting do
   case datetag of
@@ -3464,36 +4485,12 @@
         end;
       end;
-  1:  begin
-        FMStartDate := FMToday;
-        FMStopDate := endofday;
-      end;
-  2:  begin
-        FMStartDate := FMDateTimeOffsetBy(FMToday, -7);
-        FMStopDate := endofday;
-      end;
-  3:  begin
-        FMStartDate := FMDateTimeOffsetBy(FMToday, -14);
-        FMStopDate := endofday;
-      end;
-  4:  begin
-        FMStartDate := FMDateTimeOffsetBy(FMToday, -30);
-        FMStopDate := endofday;
-      end;
-  5:  begin
-        FMStartDate := FMDateTimeOffsetBy(FMToday, -183);
-        FMStopDate := endofday;
-      end;
-  6:  begin
-        FMStartDate := FMDateTimeOffsetBy(FMToday, -365);
-        FMStopDate := endofday;
-      end;
-  7:  begin
-        FMStartDate := FMDateTimeOffsetBy(FMToday, -730);
-        FMStopDate := endofday;
-      end;
-  8:  begin
-        FMStartDate := FM_START_DATE;   // earliest recorded values
-        FMStopDate := endofday;
-      end;
+  1:  FMStartDate := FMToday;
+  2:  FMStartDate := FMDateTimeOffsetBy(FMToday, -7);
+  3:  FMStartDate := FMDateTimeOffsetBy(FMToday, -14);
+  4:  FMStartDate := FMDateTimeOffsetBy(FMToday, -30);
+  5:  FMStartDate := FMDateTimeOffsetBy(FMToday, -183);
+  6:  FMStartDate := FMDateTimeOffsetBy(FMToday, -365);
+  7:  FMStartDate := FMDateTimeOffsetBy(FMToday, -730);
+  8:  FMStartDate := FM_START_DATE;   // earliest recorded values
   else
       begin
@@ -3512,12 +4509,4 @@
       end;
   end;
-  FilterListView(FGraphSetting.FMStartDate, FGraphSetting.FMStopDate);
-  SelReset(lstSelCopyTop, lvwItemsTop);
-  SelReset(lstSelCopyBottom, lvwItemsBottom);
-  DisplayData('top');
-  DisplayData('bottom');
-  if cboViewsTop.ItemIndex > 1 then cboViewsTopChange(self);
-  if cboViewsBottom.ItemIndex > 1 then cboViewsBottomChange(self);
-  HideGraphs(false);
 end;
 
@@ -3609,49 +4598,52 @@
 var
   actionOK, checkaction: boolean;
-  counter, i, listnum: integer;
-  profile, profilestring, section, selections, specnum, typeitem: string;
+  counter: integer;
+  profile, profilestring, section, selections, specnum, typeitem, seltext: string;
   aGraphItem: TGraphItem;
+  aListItem: TListItem;
 begin
   selections := '';
-  for i := 0 to lvwItemsTop.Items.Count - 1 do
-  if lvwItemsTop.Items[i].Selected then
-  begin
-    aGraphItem := TGraphItem(lvwItemsTop.Items.Item[i].SubItems.Objects[3]);
+  seltext := '';
+  aListItem := lvwItemsTop.Selected;
+  while aListItem <> nil do
+  begin
+    aGraphItem := TGraphItem(aListItem.SubItems.Objects[3]);
     typeitem := UpperCase(aGraphItem.Values);
     if Piece(typeitem, '^', 1) = '63' then
     begin
       specnum := Piece(Piece(typeitem, '^', 2), '.', 2);
-      if length(specnum) > 0 then  // mulispecimen
+      if length(specnum) > 0 then  // multispecimen
         if specnum = '1' then typeitem := Piece(typeitem, '.', 1)
         else typeitem := '';
     end;
     if length(typeitem) > 0 then
-      selections := selections + Piece(typeitem, '^', 1) + '~' + Piece(typeitem, '^', 2) +'~|';
-  end;
-  checkaction := chkDualViews.Checked;
+      selections := selections + Piece(typeitem, '^', 1) + '~' + Piece(typeitem, '^', 2) + '~|';
+    aListItem := lvwItemsTop.GetNextItem(aListItem, sdAll, [isSelected]);
+  end;
+  checkaction := false;
   actionOK := false;
   profile := '*';
-  counter := cboViewsTop.Tag;
-  // load lstItems with all patient items and pass to Define View    ????
-  DialogGraphProfiles(Font.Size, actionOK, checkaction, FGraphSetting,
+  counter := lstViewsTop.Tag;
+  // load GtslItems with all patient items and pass to Define View    ????
+  DialogGraphProfiles(actionOK, checkaction, FGraphSetting,
     profile, profilestring, section, Patient.DFN, counter, selections);
   if (not actionOK) then exit;
   FillViews;
   if (section = 'niether') then exit;
-  cboViewsTop.Tag := counter;
-
-  lstViews.Items.Add(profilestring);
-  listnum := lstViews.Items.Count + 1;
-  for i := 0 to lstViews.Items.Count - 1 do
-  begin
-    profilestring := lstViews.Items[i];
-    cboViewsTop.Items.Insert(i + 2, profilestring);
-    cboViewsBottom.Items.Insert(i + 2, profilestring);
-  end;
+  lstViewsTop.Tag := counter;
   if (section = 'bottom') or (section = 'both') then
-    lvwItemsBottom.Tag := listnum;
+    lvwItemsBottom.Tag := counter;
   if (section = 'top') or (section = 'both') then
-    lvwItemsTop.Tag  := listnum;
+    lvwItemsTop.Tag  := counter;
   ViewSelections;
+end;
+
+procedure TfrmGraphs.DisplayFreeText(aChart: TChart);
+var
+  i: integer;
+begin
+  for i := 0 to aChart.SeriesCount - 1 do
+    if (Piece(aChart.Series[i].Title, '^', 1) = '(non-numeric)') then
+      aChart.Series[i].Marks.Visible := true;
 end;
 
@@ -3664,8 +4656,8 @@
     if (Tag = 0) and (length(lvwItemsBottom.Hint) > 0) then
     begin
-      for i := 0 to cboViewsBottom.Items.Count - 1 do
+      for i := 0 to lstViewsBottom.Items.Count - 1 do
       begin
-        showmessage(cboViewsBottom.Items[i]);
-        if lvwItemsBottom.Hint = Piece(cboViewsBottom.Items[i], '^', 2) then
+        ShowMsg(lstViewsBottom.Items[i]);
+        if lvwItemsBottom.Hint = Piece(lstViewsBottom.Items[i], '^', 2) then
         begin
           Tag := i;
@@ -3682,8 +4674,8 @@
       end;
       ClearSelection;
-      cboViewsBottom.ItemIndex := Tag;
+      lstViewsBottom.ItemIndex := Tag;
       Tag := 0;
       Hint := '';
-      cboViewsBottomChange(self);
+      lstViewsBottomChange(lstViewsBottom);
     end;
   end;
@@ -3691,21 +4683,17 @@
   begin
     if (Tag = 0) and (length(lvwItemsTop.Hint) > 0) then
-    begin
-      for i := 0 to cboViewsTop.Items.Count - 1 do
-      begin
-        if lvwItemsTop.Hint = Piece(cboViewsTop.Items[i], '^', 2) then
+      for i := 0 to lstViewsTop.Items.Count - 1 do
+        if lvwItemsTop.Hint = Piece(lstViewsTop.Items[i], '^', 2) then
         begin
           Tag := i;
           break;
         end;
-      end;
-    end;
     if Tag > 0 then
     begin
       ClearSelection;
-      cboViewsTop.ItemIndex := Tag;
+      lstViewsTop.ItemIndex := Tag;
       Tag := 0;
       Hint := '';
-      cboViewsTopChange(self);
+      lstViewsTopChange(lstViewsTop);
     end;
   end;
@@ -3713,7 +4701,7 @@
 
 procedure TfrmGraphs.ItemsClick(Sender: TObject; aListView, aOtherListView: TListView;
-  aCheckBox: TCheckBox; aComboBox: TORComboBox; aList: TListBox; aSection: string);
-begin
-  FRetainZoom := (lstZoomHistory.Count > 0);
+  aCheckBox: TCheckBox; aListBox: TORListBox; aList: TStrings; aSection: string);
+begin
+  FRetainZoom := (GtslZoomHistoryFloat.Count > 0);
   FWarning := false;
   Screen.Cursor := crHourGlass;
@@ -3721,9 +4709,10 @@
   if Sender = aListView then
   begin
-    aComboBox.ItemIndex := -1;
-    aComboBox.Text := '';
+    aListBox.Tag := BIG_NUMBER;                   // avoids recurssion
+    aListBox.ItemIndex := -1;
+    aListBox.ClearSelection;
   end;
   if (Sender is TListView) then           // clear out selcopy list
-    aList.Items.Clear;
+    aList.Clear;
   if aOtherListView.SelCount < 1 then
   begin
@@ -3755,9 +4744,9 @@
   if (aListView.SelCount = 1) and (aOtherListView.SelCount = 0) then
   begin
-    lstZoomHistory.Items.Clear;
+    GtslZoomHistoryFloat.Clear;
     FRetainZoom := false;
     mnuPopGraphZoomBack.Enabled := false;
   end
-  else if FRetainZoom and (lstZoomHistory.Count > 0) then
+  else if FRetainZoom and (GtslZoomHistoryFloat.Count > 0) then
     ZoomUpdate;
   HideGraphs(false);
@@ -3774,4 +4763,7 @@
   aGraphItem: TGraphItem;
 begin
+  if FFastTrack then
+    exit;
+  Application.ProcessMessages;
   TypeToCheck := UpperCase(TypeToCheck);
   if (TypeToCheck = 'SELECT') and (lvwItemsTop.SelCount = 0)
@@ -3794,9 +4786,8 @@
       done := false;
       j := 0;
-      with lstCheck do
       while not done do
       begin
-        if Items.Count = j then done := true
-        else if lstCheck.Items[j] = typeitem then
+        if GtslCheck.Count = j then done := true
+        else if Pieces(GtslCheck[j], '^', 1, 2) = typeitem then
         begin
           previous := true;
@@ -3807,10 +4798,10 @@
       if not previous then
       begin
-        lstCheck.Items.Add(typeitem);
+        GtslCheck.Add(typeitem);
         itemname := aListView.Items[i].Caption;
         if Piece(typeitem, '^', 1) = '63' then
-          LabData(typeitem, itemname, aSection)
+          LabData(typeitem, itemname, aSection, true) // need to get lab data
         else
-          lstData.Items.AddStrings(rpcGetItemData(typeitem, FMTimeStamp, Patient.DFN));
+          FastAddStrings(rpcGetItemData(typeitem, FMTimeStamp, Patient.DFN), GtslData);
       end;
     end;
@@ -3818,69 +4809,54 @@
 end;
 
-procedure TfrmGraphs.lvwItemsTopClick(Sender: TObject);
+procedure TfrmGraphs.lvwItemsBottomClick(Sender: TObject);
 var
   i: integer;
 begin
   FFirstClick := true;
-  with FGraphSetting do
-  if lvwItemsTop.SelCount > MaxSelect then
-  begin
-    pnlItemsTopInfo.Tag := 1;
-    lvwItemsTop.ClearSelection;
-    showmessage('Too many items to graph');
-    for i := 0 to lstSelPrevTop.Items.Count - 1 do
-      lvwItemsTop.Items[strtoint(lstSelPrevTop.Items[i])].Selected := true;
-    pnlItemsTopInfo.Tag := 0;
-  end
-  else
-  begin
-    lstSelPrevTop.Clear;
-    for i := 0 to lvwItemsTop.Items.Count - 1 do
-      if lvwItemsTop.Items[i].Selected then lstSelPrevTop.Items.Add(inttostr(i));
-    ItemsClick(Sender, lvwItemsTop, lvwItemsBottom, chkItemsTop, cboViewsTop, lstSelCopyTop, 'top');
-  end;
-end;
-
-procedure TfrmGraphs.lvwItemsBottomClick(Sender: TObject);
-var
-  i: integer;
-begin
-  FFirstClick := true;
-  with FGraphSetting do
-  if lvwItemsBottom.SelCount > MaxSelect then
+  if not FFastTrack then
+    if GraphTurboOn then
+      Switch;
+  if lvwItemsBottom.SelCount > FGraphSetting.MaxSelect then
   begin
     pnlItemsBottomInfo.Tag := 1;
     lvwItemsBottom.ClearSelection;
-    showmessage('Too many items to graph');
-    for i := 0 to lstSelPrevBottom.Items.Count - 1 do
-      lvwItemsBottom.Items[strtoint(lstSelPrevBottom.Items[i])].Selected := true;
+    if FTooManyItems then FTooManyItems := false
+    else
+    begin
+      ShowMsg('Too many items to graph');
+      FTooManyItems := true;  // flag so that warning will not be displayed twice
+    end;
+    for i := 0 to GtslSelPrevBottomFloat.Count - 1 do
+      lvwItemsBottom.Items[strtoint(GtslSelPrevBottomFloat[i])].Selected := true;
     pnlItemsBottomInfo.Tag := 0;
   end
   else
   begin
-    lstSelPrevBottom.Clear;
+    GtslSelPrevBottomFloat.Clear;
     for i := 0 to lvwItemsBottom.Items.Count - 1 do
-      if lvwItemsBottom.Items[i].Selected then lstSelPrevBottom.Items.Add(inttostr(i));
-    ItemsClick(Sender, lvwItemsBottom, lvwItemsTop, chkItemsBottom, cboViewsBottom, lstSelCopyBottom, 'bottom');
-  end;
-end;
-
-procedure TfrmGraphs.SelCopy(aListView: TListView; aListBox: TListBox);
-var
-  i: integer;
+    if lvwItemsBottom.Items[i].Selected then
+      GtslSelPrevBottomFloat.Add(inttostr(i));
+    ItemsClick(Sender, lvwItemsBottom, lvwItemsTop, chkItemsBottom, lstViewsBottom, GtslSelCopyBottom, 'bottom');
+  end;
+end;
+
+procedure TfrmGraphs.SelCopy(aListView: TListView; aList: TStrings);
+var
   aGraphItem: TGraphItem;
+  aListItem: TListItem;
 begin
   if aListView.Items.Count > 0 then
   begin
-    for i := 0 to aListView.Items.Count - 1 do
-    if aListView.Items[i].Selected then
-    begin
-      aGraphItem := TGraphItem(aListView.Items.Item[i].SubItems.Objects[3]);    //get file^ien match
-      aListBox.Items.Add(aGraphItem.Values);
-    end;
-  end;
-end;
-
-procedure TfrmGraphs.SelReset(aListbox: TListBox; aListView: TListView);
+    aListItem := aListView.Selected;
+    while aListItem <> nil do
+    begin
+      aGraphItem := TGraphItem(aListItem.SubItems.Objects[3]);    //get file^ien match
+      aList.Add(aGraphItem.Values);
+      aListItem := aListView.GetNextItem(aListItem, sdAll, [isSelected]);
+    end;
+  end;
+end;
+
+procedure TfrmGraphs.SelReset(aList: TStrings; aListView: TListView);
 var
   i, j: integer;
@@ -3892,7 +4868,7 @@
     aGraphItem := TGraphItem(aListView.Items.Item[i].SubItems.Objects[3]);    //get file^ien match
     typeitem := UpperCase(Pieces(aGraphItem.Values, '^', 1, 3));
-    for j := 0 to aListBox.Items.Count - 1 do
-    begin
-      itemtype := UpperCase(Pieces(aListBox.Items[j], '^', 1, 3));
+    for j := 0 to aList.Count - 1 do
+    begin
+      itemtype := UpperCase(Pieces(aList[j], '^', 1, 3));
       if itemtype = typeitem then
       begin
@@ -3904,5 +4880,5 @@
 end;
 
-procedure TfrmGraphs.ViewsChange(aListView: TListView; aComboBox: TORComboBox; aSection: string);
+procedure TfrmGraphs.ViewsChange(aListView: TListView; aListBox: TORListBox; aSection: string);
 var
   Updated: boolean;
@@ -3911,8 +4887,11 @@
   timHintPause.Enabled := false;
   InactivateHint;
-  if aComboBox.ItemIndex = -1 then exit;  // or clear graph  ***************************
-  if aComboBox.ItemIndex = 0 then  // <clear all selections>
-  begin
-    aComboBox.Text := '';
+  if aListBox.ItemIndex = -1 then exit;  // or clear graph  ***************************
+  if aListBox.Tag = BIG_NUMBER then            // avoids recurssion
+    exit;
+  if pos(LLS_FRONT, aListBox.Items[aListBox.ItemIndex]) > 0 then  // <clear all selections>
+  begin
+    if aListBox.Tag = BIG_NUMBER then            // avoids recurssion
+      exit;
     aListView.ClearSelection;
     if aSection = 'top' then
@@ -3920,4 +4899,6 @@
       FTHighTime := 0;
       FTLowTime := BIG_NUMBER;
+      memViewsTop.Lines.Clear;
+      memViewsTop.Lines[0] := TXT_VIEW_DEFINITION;
     end
     else
@@ -3925,25 +4906,22 @@
       FBHighTime := 0;
       FBLowTime := BIG_NUMBER;
+      memViewsBottom.Lines.Clear;
+      memViewsBottom.Lines[0] := TXT_VIEW_DEFINITION;
     end;
     DisplayData(aSection);
+    aListBox.Tag := 0;                     // reset
     exit;
   end;
-  if aComboBox.ItemIndex = 1 then  // <make selections>
-  begin
-    btnGraphSelectionsClick(self);
-    if aComboBox.ItemIndex = -1 then
-      aComboBox.Text := '';
-    exit;
-  end;                            // view selected
   aListView.ClearSelection;
   Updated := false;
-  aProfile := aComboBox.Items[aComboBox.ItemIndex];
-  if (length(Piece(aProfile, '^', 3)) = 0) or (length(Piece(aProfile, '^', 1)) = 0) then        //or <custom>
+  aProfile := aListBox.Items[aListBox.ItemIndex];
+  if (length(Piece(aProfile, '^', 3)) = 0) or (length(Piece(aProfile, '^', 1)) = 0) or
+     (Piece(aProfile, '^', 1) = VIEW_LABS) then        //or <custom>
     CheckProfile(aProfile, Updated);
-  aComboBox.Text := Piece(aProfile, '^', 2);
   if Updated then
     cboDateRangeChange(self);
   if aSection = 'top' then
   begin
+    ViewDefinition(aProfile, memViewsTop);
     AssignProfile(aProfile, 'top');
     if not FItemsSortedTop then
@@ -3957,4 +4935,5 @@
   else
   begin
+    ViewDefinition(aProfile, memViewsBottom);
     AssignProfile(aProfile, 'bottom');
     if not FItemsSortedBottom then
@@ -3971,14 +4950,4 @@
 end;
 
-procedure TfrmGraphs.cboViewsTopChange(Sender: TObject);
-begin
-  ViewsChange(lvwItemsTop, cboViewsTop, 'top');
-end;
-
-procedure TfrmGraphs.cboViewsBottomChange(Sender: TObject);
-begin
-  ViewsChange(lvwItemsBottom, cboViewsBottom, 'bottom');
-end;
-
 procedure TfrmGraphs.AssignProfile(aProfile, aSection: string);
 var
